---
title: "OT"
author: "Jean Feydy"
institute: ""
topic: ""
theme: "metropolis"
colortheme:
fonttheme:
fontsize: 11pt
linkcolor: black
urlcolor: blue
linkstyle: bold
aspectratio: 169
titlegraphic: 
logo:
date:
section-titles: false
toc: false
---


## Who do you want to trust?

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/sandwich_auchan.jpg){height=6.2cm}

**A triangle sandwich,** \
with soulless packaging. \
`\end{center}`{=latex}
::::
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/sandwich_rosette.jpg){height=6.2cm}

**A fresh sandouiche,** \
are you salivating yet? \
`\end{center}`{=latex}
::::
:::



## Who do you want to trust?

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/matplotlib_3D.png){height=6.2cm}

**A trefoil knot,** \
with default Matplotlib settings. \
`\end{center}`{=latex}
::::
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/surface/60_silhouette_0.02.jpg){height=6.2cm}

**The same data,** \
with 10 lines of PyVista code. \
`\end{center}`{=latex}
::::
:::




## But Jean... I'm just a mathematician!

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=55%}

`\vspace*{0.7cm}`{=latex}

 \
Creating great 3D figures takes some time but: \
 \

- **Can now be done in minutes** with PyVista, a transparent Matplotlib replacement. \
   \
- **Demonstrates** a familiarity with the `\BR{state-of-the-art}`{=latex} in geometry processing. \
   \
- **Sets you apart** from the `\BR{low-effort papers}`{=latex} that are flooding reviewers' mail boxes.


::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/keenan.png){height=6.2cm}
Keenan Crane **signals competence** \
with every single figure.
`\end{center}`{=latex}
::::
:::




## The Visualization ToolKit (VTK) -- going strong since 1993.


::: columns
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/pyvista.png){height=6.2cm}

**PyVista** -- the pythonic API.
`\end{center}`{=latex}
::::
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/paraview.png){height=6.2cm}

**Paraview** -- the interactive GUI.
`\end{center}`{=latex}
::::
:::




## Today’s talk -- demystifying the graphics toolbox

1. Tips and tricks with $\BR{PyVista}$. \
   Subdivision? Culling? SSAO? PBR? \
    \

2. Links to **advanced resources**. \
   The maths behind the simple functions. \
    \

3. Interactive $\BR{Paraview}$ demo. \
   With real data :-)




## Opening a PyVista window -- import pyvista as pv


`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=55%}
```{=latex}

\vspace*{.7cm}

\TT{%
pl = pv.\BR{Plotter}(window\_size=[800, 800]) \\
~\\
S = pv.\BR{PolyData}( \\
~~~~[[x1, y1, z1], [x2, y2, z2], ...], \\
~~~~\textbf{faces}=[\textbf{3}, a, b, c, \textbf{3}, d, e, f, ...], \\
) \\
pl.\BR{add\_mesh}(S) \\
~\\
pl.camera\_position = "xy" \\
pl.camera.zoom(1.4) \\
pl.\textbf{enable\_anti\_aliasing("ssaa")} \\
pl.\textbf{enable\_parallel\_projection()} \\
~\\
pl.show() \\
pl.screenshot("knot.jpg") \\
}
```
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/pyvista_window.jpg){height=6.2cm}

A **"flat"** 3D rendering \
of our trefoil knot.
`\end{center}`{=latex}
::::
:::



## Anti-aliasing matters, especially for small screenshots -- 200x200 below

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/0_antialiasing_False.png){height=6.2cm}

`\TT{pl.\textbf{\BR{disable}\_anti\_aliasing}()}`{=latex} \
One sample per pixel.
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/0_antialiasing_True.png){height=6.2cm}

`\TT{pl.\textbf{\BR{enable}\_anti\_aliasing}()}`{=latex} \
Multiple samples per pixel.
`\end{center}`{=latex}
::::
:::



## Parallel projection -- a bit better for scientific visualization?

`\vspace*{0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/aom.jpg){height=6.2cm}

Default 3D perspective. \
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/aoe2.jpg){height=6.2cm}

`\TT{pl.\textbf{\BR{enable}\_parallel\_projection}()}`{=latex} \
`\end{center}`{=latex}
::::
:::


# Smoothness


## From flat to Gouraud shading with point normals

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/surface/1_data_raw.jpg){height=6.2cm}
`\TT{pl.\textbf{add\_mesh}(S)}`{=latex} \
Raw data with flat shading.
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/surface/2_data_smooth.jpg){height=6.2cm}
`\TT{pl.\textbf{add\_mesh}(S, \BR{smooth\_shading=True})}`{=latex} \
Interpolate point normals.
`\end{center}`{=latex}
::::
:::



## Getting smoother geometry: with linear subdivision?

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/3_subdivision_linear_raw_0.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/4_subdivision_linear_smooth_0.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{S = S.\textbf{subdivide}(subfilter=\BR{"linear"}, nsub=0)}`{=latex} \
`\end{center}`{=latex}



## Getting smoother geometry: with linear subdivision?

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/5_subdivision_linear_raw_1.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/6_subdivision_linear_smooth_1.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{S = S.\textbf{subdivide}(subfilter=\BR{"linear"}, nsub=1)}`{=latex} \
`\end{center}`{=latex}




## Getting smoother geometry: with linear subdivision?

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/7_subdivision_linear_raw_2.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/8_subdivision_linear_smooth_2.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{S = S.\textbf{subdivide}(subfilter=\BR{"linear"}, nsub=2)}`{=latex} \
`\end{center}`{=latex}




## Getting smoother geometry: with linear subdivision?

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/9_subdivision_linear_raw_3.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/10_subdivision_linear_smooth_3.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{S = S.\textbf{subdivide}(subfilter=\BR{"linear"}, nsub=3)}`{=latex} \
`\end{center}`{=latex}




## Getting smoother geometry: with linear subdivision?

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/11_subdivision_linear_raw_4.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/12_subdivision_linear_smooth_4.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{S = S.\textbf{subdivide}(subfilter=\BR{"linear"}, nsub=4)}`{=latex} \
`\end{center}`{=latex}

















## Getting smoother geometry: with loop subdivision!

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/13_subdivision_loop_raw_0.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/14_subdivision_loop_smooth_0.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{S = S.\textbf{subdivide}(subfilter=\BR{"loop"}, nsub=0)}`{=latex} \
`\end{center}`{=latex}



## Getting smoother geometry: with loop subdivision!

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/15_subdivision_loop_raw_1.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/16_subdivision_loop_smooth_1.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{S = S.\textbf{subdivide}(subfilter=\BR{"loop"}, nsub=1)}`{=latex} \
`\end{center}`{=latex}



## Getting smoother geometry: with loop subdivision!

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/17_subdivision_loop_raw_2.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/18_subdivision_loop_smooth_2.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{S = S.\textbf{subdivide}(subfilter=\BR{"loop"}, nsub=2)}`{=latex} \
`\end{center}`{=latex}




## Getting smoother geometry: with loop subdivision!

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/19_subdivision_loop_raw_3.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/20_subdivision_loop_smooth_3.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{S = S.\textbf{subdivide}(subfilter=\BR{"loop"}, nsub=3)}`{=latex} \
`\end{center}`{=latex}



## Getting smoother geometry: with loop subdivision!

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/21_subdivision_loop_raw_4.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/22_subdivision_loop_smooth_4.jpg){height=6.2cm}
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{S = S.\textbf{subdivide}(subfilter=\BR{"loop"}, nsub=4)}`{=latex} \
`\textbf{This is not}`{=latex} $\BR{``cheating''}$ -- why stick to linear interpolation for smooth data?
`\end{center}`{=latex}


## Interesting mathematics behind subdivision surfaces

`\vspace*{0.2cm}`{=latex}

::: columns
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/subdivision/De_Casteljau.jpg){height=6.2cm}

**De Casteljau's algorithm,** \
courtesy of Gabriel Peyré.

`\end{center}`{=latex}
::::
:::: {.column width=48%}

```{=latex}
\begin{center}\vspace*{.5cm}

\only<1>{\includegraphics[width=\textwidth,height=6.2cm]{images/subdivision/corrugations_0.jpg}}%
\only<2>{\includegraphics[width=\textwidth,height=6.2cm]{images/subdivision/corrugations_1.jpg}}%
\only<3>{\includegraphics[width=\textwidth,height=6.2cm]{images/subdivision/corrugations_2.jpg}}%
\only<4>{\includegraphics[width=\textwidth,height=6.2cm]{images/subdivision/corrugations_3.jpg}}%
\only<5>{\includegraphics[width=\textwidth,height=6.2cm]{images/subdivision/corrugations_4.jpg}}%

\vspace*{.2cm}
```

The **flat torus** embedded in $\mathbb{R}^3$ \
by the Hevea project.
`\end{center}`{=latex}
::::
:::


# Colors


## Adding some colors

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/23_signal_viridis.jpg){height=6.2cm}
`\TT{\textbf{cmap}=\BR{"viridis"}}`{=latex} \
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/24_signal_plasma.jpg){height=6.2cm}
`\TT{\textbf{cmap}=\BR{"plasma"}}`{=latex} \
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{pl.\textbf{add\_mesh}(S, \textbf{scalars}=S.curvature("gaussian"), \textbf{cmap}=cmap, \textbf{clim}=(-1, 1))}`{=latex} \
`\end{center}`{=latex}




## Adding some colors: beware of perceptual artifacts

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/25_signal_coolwarm.jpg){height=6.2cm}
`\TT{\textbf{cmap}=\BR{"coolwarm"}}`{=latex} \
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/26_signal_bwr.jpg){height=6.2cm}
`\TT{\textbf{cmap}=\BR{"bwr"}}`{=latex} \
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{pl.\textbf{add\_mesh}(S, \textbf{scalars}=S.curvature("gaussian"), \textbf{cmap}=cmap, \textbf{clim}=(-1, 1))}`{=latex} \
`\end{center}`{=latex}


## Choosing a colormap

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=48%}
`\begin{center}`{=latex}
`\vspace*{.6cm}`{=latex}

![](images/munsell_color_space.png){height=6.2cm}

`\vspace*{.55cm}`{=latex}

The Munsell $\BR{perceptual}$ color space, \
from the Chromatone center.
`\end{center}`{=latex}
::::
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/matplotlib_colormaps.png){height=6.2cm}

The **Matplotlib tutorial** \
on the subject.

`\end{center}`{=latex}
::::
:::


## Adding some colors: append `\texttt{"\_r"}`{=latex} to reverse colormaps

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/27_signal_RdBu.jpg){height=6.2cm}
`\TT{\textbf{cmap}=\BR{"RdBu"}}`{=latex} \
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/28_signal_RdBu_r.jpg){height=6.2cm}
`\TT{\textbf{cmap}=\BR{"RdBu\_r"}}`{=latex} \
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{pl.\textbf{add\_mesh}(S, \textbf{scalars}=S.curvature("gaussian"), \textbf{cmap}=cmap, \textbf{clim}=(-1, 1))}`{=latex} \
`\end{center}`{=latex}



# Lighting and material models




## Adjust lighting: ambient glow

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/29_ambient_0.jpg){height=6.2cm}
`\TT{pl.\textbf{add\_mesh}(S, \BR{ambient=0.}, ...)}`{=latex} \
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/31_ambient_0.2.jpg){height=6.2cm}
`\TT{pl.\textbf{add\_mesh}(S, \BR{ambient=0.2}, ...)}`{=latex} \
`\end{center}`{=latex}
::::
:::


## Adjust lighting: custom set with pv.Light(...)


`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=55%}
```{=latex}

\vspace*{.7cm}

\TT{%
pl = pv.\textbf{Plotter}(\\
~~~~window\_size=[800, 800], \\
~~~~\BR{lighting="none"} \\
) \\
pl.\textbf{add\_mesh}(S) \\
~\\
light = pv.\textbf{Light(intensity=0.7)} \\
light.\BR{set\_direction\_angle}(40, 90) \\
pl.\textbf{add\_light}(light) \\
~\\
light = pv.\textbf{Light(}\\
~~~~\textbf{light\_type=\BR{"headlight"},} \\
~~~~\textbf{intensity=0.7} \\
\textbf{)} \\
pl.\textbf{add\_light}(light) \\
~\\
... \\
pl.show() \\
}
```
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/33_light_ratio_0.jpg){height=6.2cm}

Our light kit.
`\end{center}`{=latex}
::::
:::




## Adjust lighting: custom set with pv.Light(...)


`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=55%}
```{=latex}

\vspace*{.7cm}

\TT{%
pl = pv.\textbf{Plotter}(\\
~~~~window\_size=[800, 800], \\
~~~~\textbf{lighting="none"} \\
) \\
pl.\textbf{add\_mesh}(S) \\
~\\
light = pv.\textbf{Light(intensity=\BR{1.2})} \\
light.\textbf{set\_direction\_angle}(40, 90) \\
pl.\textbf{add\_light}(light) \\
~\\
light = pv.\textbf{Light(}\\
~~~~\textbf{light\_type="headlight",} \\
~~~~\textbf{intensity=\BR{0.2}} \\
\textbf{)} \\
pl.\textbf{add\_light}(light) \\
~\\
... \\
pl.show() \\
}
```
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/32_light_ratio_-0.5.jpg){height=6.2cm}

Less headlight.
`\end{center}`{=latex}
::::
:::




## Adjust lighting: custom set with pv.Light(...)


`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=55%}
```{=latex}

\vspace*{.7cm}

\TT{%
pl = pv.\textbf{Plotter}(\\
~~~~window\_size=[800, 800], \\
~~~~\textbf{lighting="none"} \\
) \\
pl.\textbf{add\_mesh}(S) \\
~\\
light = pv.\textbf{Light(intensity=\BR{0.2})} \\
light.\textbf{set\_direction\_angle}(40, 90) \\
pl.\textbf{add\_light}(light) \\
~\\
light = pv.\textbf{Light(}\\
~~~~\textbf{light\_type="headlight",} \\
~~~~\textbf{intensity=\BR{1.2}} \\
\textbf{)} \\
pl.\textbf{add\_light}(light) \\
~\\
... \\
pl.show() \\
}
```
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/34_light_ratio_0.5.jpg){height=6.2cm}

More headlight.
`\end{center}`{=latex}
::::
:::



## Adjust lighting: include shadows!

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/35_shadows_False.jpg){height=6.2cm}
Default rendering. \
Hard to read.
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/36_shadows_True.jpg){height=6.2cm}
`\TT{pl.\textbf{enable\_\BR{shadows}()}}`{=latex} \
Realistic shadow casting.
`\end{center}`{=latex}
::::
:::




## Adjust lighting: pseudo-shadows

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/37_shadows_ssao.jpg){height=6.2cm}
`\TT{pl.\textbf{enable\_\BR{ssao}(radius=1)}}`{=latex} \
Screen Space Ambient Occlusion.
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/38_shadows_edl.jpg){height=6.2cm}
`\TT{pl.\textbf{enable\_\BR{eye\_dome\_lighting}()}}`{=latex} \
Highlighting contours from the inside.
`\end{center}`{=latex}
::::
:::




## Adjust the material model with Physics Based Rendering (PBR)


`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=35%}
`\begin{center}`{=latex}
![](images/rendering_equation.png){height=6.2cm}

$\BR{Microfacets}$ and the rendering \
equation, by **Cem Yuksel**.
`\end{center}`{=latex}
::::
:::: {.column width=62%}
`\begin{center}`{=latex}
![](images/streamlines.jpg){height=6.2cm}

$\BR{VTK}$ supports PBR since 2019. \
Made in **Lyon**!
`\end{center}`{=latex}
::::
:::



## Adjust the material model with Physics Based Rendering (PBR)

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/41_pbr_metallic_0.0_roughness_0.8_cubemap_False.jpg){height=6.2cm}
`\TT{\textbf{metallic}=0, \textbf{roughness}=0.8}`{=latex} \
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/47_pbr_metallic_1.0_roughness_0.8_cubemap_False.jpg){height=6.2cm}
`\TT{\textbf{metallic}=1, \textbf{roughness}=0.8}`{=latex} \
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{pl.\textbf{add\_mesh}(S, \BR{pbr=True}, \textbf{metallic}=m, \textbf{roughness}=r, ...)}`{=latex} \
`\end{center}`{=latex}





## Adjust the material model with Physics Based Rendering (PBR)

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/40_pbr_metallic_0.0_roughness_0.4_cubemap_False.jpg){height=6.2cm}
`\TT{\textbf{metallic}=0, \textbf{roughness}=0.4}`{=latex} \
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/46_pbr_metallic_1.0_roughness_0.4_cubemap_False.jpg){height=6.2cm}
`\TT{\textbf{metallic}=1, \textbf{roughness}=0.4}`{=latex} \
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{pl.\textbf{add\_mesh}(S, \BR{pbr=True}, \textbf{metallic}=m, \textbf{roughness}=r, ...)}`{=latex} \
`\end{center}`{=latex}





## Adjust the material model with Physics Based Rendering (PBR)

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/39_pbr_metallic_0.0_roughness_0.2_cubemap_False.jpg){height=6.2cm}
`\TT{\textbf{metallic}=0, \textbf{roughness}=0.2}`{=latex} \
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/45_pbr_metallic_1.0_roughness_0.2_cubemap_False.jpg){height=6.2cm}
`\TT{\textbf{metallic}=1, \textbf{roughness}=0.2}`{=latex} \
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{pl.\textbf{add\_mesh}(S, \BR{pbr=True}, \textbf{metallic}=m, \textbf{roughness}=r, ...)}`{=latex} \
`\end{center}`{=latex}



## Add a cubemap -- and some more lights


`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=55%}
```{=latex}

\vspace*{.7cm}

\TT{%
\textbf{cubemap} = \ ~\\
pv.examples.download\_sky\_box\_cube\_map() \\
pl.\BR{set\_environment\_texture}(cubemap) \\
~\\
\textbf{if show\_background:} \\
~~~~pl.\BR{add\_actor}(cubemap.to\_skybox()) \\
~\\
light = pv.\textbf{Light}(intensity=1.0) \\
light.set\_direction\_angle(40, 90) \\
\textbf{for \_ in range(3):}\\
~~~~pl.\textbf{add\_light}(light) \\
~\\
... \\
pl.show() \\
}
```
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
`\vspace*{.7cm}`{=latex}
![](images/cubemap.png){height=6.2cm}

`\vspace*{.2cm}`{=latex}

A **cubemap** encodes the $\BR{environment}$ \
lighting using **6 square images**.
`\end{center}`{=latex}
::::
:::



## Adjust the material model with Physics Based Rendering (PBR)

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/50_pbr_metallic_0.0_roughness_0.8_cubemap_True.jpg){height=6.2cm}
`\TT{\textbf{metallic}=0.5, \textbf{roughness}=0.8}`{=latex} \
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/56_pbr_metallic_1.0_roughness_0.8_cubemap_True.jpg){height=6.2cm}
`\TT{\textbf{metallic}=1, \textbf{roughness}=0.8}`{=latex} \
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{pl.\textbf{add\_mesh}(S, \BR{pbr=True}, \textbf{metallic}=m, \textbf{roughness}=r, ...)}`{=latex} \
`\end{center}`{=latex}





## Adjust the material model with Physics Based Rendering (PBR)

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/49_pbr_metallic_0.0_roughness_0.4_cubemap_True.jpg){height=6.2cm}
`\TT{\textbf{metallic}=0.5, \textbf{roughness}=0.4}`{=latex} \
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/55_pbr_metallic_1.0_roughness_0.4_cubemap_True.jpg){height=6.2cm}
`\TT{\textbf{metallic}=1, \textbf{roughness}=0.4}`{=latex} \
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{pl.\textbf{add\_mesh}(S, \BR{pbr=True}, \textbf{metallic}=m, \textbf{roughness}=r, ...)}`{=latex} \
`\end{center}`{=latex}





## Adjust the material model with Physics Based Rendering (PBR)

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/48_pbr_metallic_0.0_roughness_0.2_cubemap_True.jpg){height=6.2cm}
`\TT{\textbf{metallic}=0.5, \textbf{roughness}=0.2}`{=latex} \
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/54_pbr_metallic_1.0_roughness_0.2_cubemap_True.jpg){height=6.2cm}
`\TT{\textbf{metallic}=1, \textbf{roughness}=0.2}`{=latex} \
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{pl.\textbf{add\_mesh}(S, \BR{pbr=True}, \textbf{metallic}=m, \textbf{roughness}=r, ...)}`{=latex} \
`\end{center}`{=latex}


# Silhouettes and animations


## Highlight the silhouette with a simple filtering step

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=55%}
```{=latex}

\vspace*{.7cm}

~\\
~\\
Extract the \textbf{mesh edges} that look ``tangent'' \\
and draw them with a \textbf{bold marker}.
~\\
~\\

\TT{%
pl.\textbf{add\_mesh}( \\
~~~~S, \\
~~~~\BR{silhouette}=dict( \\
~~~~~~~~\textbf{color}="black", \\
~~~~~~~~\textbf{line\_width}=10.0, \\
~~~~), \\
~~~~... \\
)
}
```
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/57_silhouette_filter.jpg){height=6.2cm}
Fast and simple, but crenelated.
`\end{center}`{=latex}
::::
:::


## Highlight the silhouette with a black shell

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=55%}

```{=latex}

\vspace*{.7cm}

\textbf{Inflate the mesh}, paint it black, \\
and \BR{cull the triangles} facing the camera. \\
~\\

\TT{%
S["sw"] = w * \textbf{np.ones}(surface.n\_points) \\
shell = S.\BR{warp\_by\_scalar}(scalars="sw") \\
~\\
pl.add\_mesh(S, ...) \\
pl.add\_mesh( \\
~~~~shell, \\
~~~~\textbf{color="black"}, \\
~~~~\BR{culling="front"}, \\
~~~~interpolation="pbr", \\
~~~~roughness=1, \\
)
}
```

::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/59_silhouette_0.01.jpg){height=6.2cm}
`\TT{\textbf{w} = 0.01}`{=latex} \
`\end{center}`{=latex}
::::
:::



## Highlight the silhouette with a black shell

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=55%}

```{=latex}

\vspace*{.7cm}

\textbf{Inflate the mesh}, paint it black, \\
and \BR{cull the triangles} facing the camera. \\
~\\

\TT{%
S["sw"] = w * \textbf{np.ones}(surface.n\_points) \\
shell = S.\BR{warp\_by\_scalar}(scalars="sw") \\
~\\
pl.add\_mesh(S, ...) \\
pl.add\_mesh( \\
~~~~shell, \\
~~~~\textbf{color="black"}, \\
~~~~\BR{culling="front"}, \\
~~~~interpolation="pbr", \\
~~~~roughness=1, \\
)
}
```

::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/60_silhouette_0.02.jpg){height=6.2cm}
`\TT{\textbf{w} = 0.02}`{=latex} \
`\end{center}`{=latex}
::::
:::


## Highlight the silhouette with a black shell

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=55%}

```{=latex}

\vspace*{.7cm}

\textbf{Inflate the mesh}, paint it black, \\
and \BR{cull the triangles} facing the camera. \\
~\\

\TT{%
S["sw"] = w * \textbf{np.ones}(surface.n\_points) \\
shell = S.\BR{warp\_by\_scalar}(scalars="sw") \\
~\\
pl.add\_mesh(S, ...) \\
pl.add\_mesh( \\
~~~~shell, \\
~~~~\textbf{color="black"}, \\
~~~~\BR{culling="front"}, \\
~~~~interpolation="pbr", \\
~~~~roughness=1, \\
)
}
```

::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/61_silhouette_0.05.jpg){height=6.2cm}
`\TT{\textbf{w} = 0.05}`{=latex} \
`\end{center}`{=latex}
::::
:::



## Create movies!

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=55%}
```{=latex}

\vspace*{.7cm}

~\\
Save screenshots and fuse them with \textbf{ffmpeg} \\
or update point features and \BR{write frames}.
~\\
~\\
~\\

\TT{%
pl.\BR{open\_movie}("flow.mp4", quality=10) \\
~\\
\textbf{for frame in range(1000):} \\
~~~~S.points += ... \\
~~~~S["signal"] = ... \\
~~~~pl.\textbf{write\_frame()} \\
~\\
pl.\textbf{close()}
}
```
::::
:::: {.column width=45%}
```{=latex}
\begin{center}
\movie[externalviewer]{
\includegraphics[height=6.2cm, keepaspectratio]{images/surface/57_silhouette_filter.jpg}
}{images/curvature_flow.mp4}

Mean curvature flow.
\end{center}
```
::::
:::






# Textures


## Define custom RGB(A) vertex colors 

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/62_xyz.jpg){height=6.2cm}
`\TT{\textbf{RGB} = \BR{S.points}}`{=latex} \
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/63_normals.jpg){height=6.2cm}
`\TT{\textbf{RGB} = (\BR{S.point\_normals} + 1) / 2}`{=latex} \
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{pl.\textbf{add\_mesh}(S, \BR{rgb=True}, \textbf{scalars}=RGB, ...)}`{=latex} \
`\end{center}`{=latex}


## Define custom UV coordinates in [0,1] and fetch RGBA from a texture image

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/64_texture_U.jpg){height=6.2cm}

**U** coordinates.
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/65_texture_V.jpg){height=6.2cm}

**V** coordinates.
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{S.\BR{active\_texture\_coordinates} = UV.reshape(S.n\_points, 2)}`{=latex} \
`\end{center}`{=latex}


## Define custom UV coordinates in [0,1] and fetch RGBA from a texture image

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/bricks.jpg){height=6.2cm}
Texture image.
`\end{center}`{=latex}
::::
:::: {.column width=5%}
::::
:::: {.column width=45%}
`\begin{center}`{=latex}
![](images/surface/66_bricks.jpg){height=6.2cm}
Textured mesh.
`\end{center}`{=latex}
::::
:::

`\begin{center}`{=latex}
`\TT{pl.\textbf{add\_mesh}(S, \BR{texture}=\textbf{pv.read\_texture("bricks.jpg")}, ...)}`{=latex} \
`\end{center}`{=latex}



## Going further with glTF models -- use textures for material properties

`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/polyhaven.png){height=6.2cm}

Download assets from \
e.g. **PolyHaven**.
`\end{center}`{=latex}
::::
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/pyvista_gltf.png){height=6.2cm}

Use them with PyVista! \
`\TT{pl.\BR{import\_gltf}(...)}`{=latex} \
`\end{center}`{=latex}
::::
:::






## Going further -- the PyVista documentation is great


`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/glyphs.png){height=6.2cm}

Use $\BR{glyphs}$ to display **arrows**.
`\end{center}`{=latex}
::::
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/point_gaussian.png){height=6.2cm}

Use $\BR{point Gaussians}$ \
for **non-uniform** point clouds. 
`\end{center}`{=latex}
::::
:::




## Going further -- two fantastic YouTube channels


`\vspace*{-0.2cm}`{=latex}

::: columns
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/branch_education.png){height=6.2cm}

$\BR{Branch Education}$'s deep dives \
into **modern hardware**.
`\end{center}`{=latex}
::::
:::: {.column width=48%}
`\begin{center}`{=latex}
![](images/cem_yuksel.png){height=6.2cm}

$\BR{Cem Yuksel}$'s lectures about \
(interactive) **computer graphics**. 
`\end{center}`{=latex}
::::
:::

# Time for a Paraview demo?



